#ifndef __sockrpc_HXX
#include "sockrpc.hxx"
#endif

#ifndef __connectd_clnt_HXX
#define __connectd_clnt_HXX

class proxy_ConnectionD : public SvcClient {

  public :
  proxy_ConnectionD(int family=AF_INET) : proxy_SvcClient("ConnectionD", family) {};
  proxy_ConnectionD(char* n, int f) : proxy_SvcClient(n,f) {}
  int import(char* filter) {
    if (this->SvcClient::import(filter)==-1) {
      return -1 ;
    } else {
      return this->SvcClient::close() ;
    }
  }
  void connect(int pid)
  {
    int numproc = 0 ;
    this->reimport() ;
    (*(SvcSocket*)this) << numproc << pid << svcflush ;
    this->close() ;
  } ;
  void beginServer(char* service, char* filter, u_int port, int pid)
  {
    int numproc = 1 ;
    this->reimport() ;
    (*(SvcSocket*)this) << numproc << service << filter << port << pid << svcflush ;
    this->close() ;
  } ;
  void stopServer(char* service, char* filter, u_int port)
  {
    int numproc = 2 ;
    this->reimport() ;
    (*(SvcSocket*)this) << numproc << service << filter << port << svcflush ;
    this->close() ;
  } ;
  void freeServer(char* service, char* filtre, u_int port)
  {
    int numproc = 3 ;
    this->reimport() ;
    (*(SvcSocket*)this) << numproc << service << filtre << port << svcflush ;
    this->close() ;
  } ;
  int askServer(char* srv, char* filt, int m, char*& h, u_int& p)
  {
    int numproc = 4 ;
    int result ;
    this->reimport() ;
    (*(SvcSocket*)this) << numproc << srv << filt << m << svcflush ;
    (*(SvcSocket*)this) >> result >> h >> p;
    this->close() ;
    return result ;
  } ;
  int askLocalServer(char* s, char* f, int m, char*& h, u_int& p)
  {
    int numproc = 5 ;
    int result ;
    this->reimport() ;
    (*(SvcSocket*)this) << numproc << s << f << m << svcflush ;
    (*(SvcSocket*)this) >> result >> h >> p;
    this->close() ;
    return result ;
  } ;
  void createDaemon(char* host)
  {
    int numproc = 6 ;
    this->reimport() ;
    (*(SvcSocket*)this) << numproc << host << svcflush ;
    this->close() ;
  } ;
  void notifyDaemon(char* host)
  {
    int numproc = 7 ;
    this->reimport() ;
    (*(SvcSocket*)this) << numproc << host << svcflush ;
    this->close() ;
  } ;
  void killDaemon(char* host)
  {
    int numproc = 8 ;
    this->reimport() ;
    (*(SvcSocket*)this) << numproc << host << svcflush ;
    this->close() ;
  } ;
  void infoLocal(ConnectdInfo& info)
  {
    int numproc = 9 ;
    this->reimport() ;
    (*(SvcSocket*)this) << numproc << svcflush ;
    (*(SvcSocket*)this) >> info;
    this->close() ;
  } ;
  void stopDaemon()
  {
    int numproc = 10 ;
    this->reimport() ;
    (*(SvcSocket*)this) << numproc << svcflush ;
    this->close() ;
  } ;
} ; 

class proxy_MasterConnectionD : public proxy_ConnectionD {

  public :
  proxy_MasterConnectionD(int family=AF_INET) : proxy_ConnectionD("MasterConnectionD", family) {};
  proxy_MasterConnectionD(char* n, int f) : proxy_ConnectionD(n,f) {}
  int import(char* filter) {
    if (this->SvcClient::import(filter)==-1) {
      return -1 ;
    } else {
      return this->SvcClient::close() ;
    }
  }
  void infoGlobal(ListVal<ConnectdInfo>& info_l)
  {
    int numproc = 11 ;
    this->reimport() ;
    (*(SvcSocket*)this) << numproc << svcflush ;
    (*(SvcSocket*)this) >> info_l;
    this->close() ;
  } ;
} ; 



#endif
